#ifndef _CEGOADMMON_H_INCLUDED_
#define _CEGOADMMON_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CegoAdmMon.h  
// ---------------
// Cego admin monitor interface definition
//
// Design and Implementation by Bjoern Lemke
//
// (C)opyright 2000-2013 Bjoern Lemke
//
// INTERFACE MODULE
//
// Class: CegoAdmMon
// 
// Description: The admin monitor interface
//
// Status: QS-2.6
//
///////////////////////////////////////////////////////////////////////////////

#include <ctype.h>
#include <string.h>

#include <lfcbase/Chain.h>
#include <lfcbase/ListT.h>
#include <lfcbase/Datetime.h>

#include "CegoAdminHandler.h"
#include <ncurses.h>
 
class CegoAdmMon {
    
public:
    
    CegoAdmMon(CegoAdminHandler *pAH);
    ~CegoAdmMon();
        
    void showMonitor();

private:

    void showHeader();

    void showPool();
    void showDBThread();
    void showAdmThread();
    void showLogThread();
    int showTableSetList();
    int showTableSet(const Chain& tableSet);

    int showMenu(const Chain& title, const ListT<Chain>& menuList);
    void printMenu(const Chain& title, const ListT<Chain>& menuList);

    ListT<Chain> _refreshMenu;
    ListT<int> _refreshOpt;


    WINDOW * _mainwin;
    WINDOW * _menuwin;

    int _highlight;
    int _mode;
    CegoAdminHandler* _pAH;

    int _tsSelected;
    int _refInterval;
    int _nextPoolRefresh;
    int _nextTSRefresh;
    int _nextTSListRefresh;
    int _nextDBRefresh;
    int _nextAdmRefresh;
    int _nextLogRefresh;

    ListT<ListT<CegoFieldValue> > _poolinfo1;
    ListT<ListT<CegoFieldValue> > _poolinfo2;
    

    ListT<ListT<CegoFieldValue> > _dbthreadinfo;    
    ListT<ListT<CegoFieldValue> > _admthreadinfo;    
    ListT<ListT<CegoFieldValue> > _logthreadinfo;    

    ListT<ListT<CegoFieldValue> > _tsList;
    ListT<ListT<CegoFieldValue> > _tsInfo;

#if HAVE_MINGW32
    void color_set(short c, void* o) {};
    void wcolor_set(WINDOW* w, short c, void* o) {};
#endif

};

#endif














